//+------------------------------------------------------------------+
//|                                        VisualOpenOrderWithMM.mq4 |
//|                                                             Itso |
//|                                                      itso@dir.bg |
//+------------------------------------------------------------------+
#property copyright "Itso"
#property link      "itso@dir.bg"
#property show_inputs
#include <stdlib.mqh>

extern double Risk              =  0.02;           //  Lot<=0         Risk
extern double Lot               =  0.1;            //  Lot>0   
extern int	  TakeProfit		  =  50;	            //      (0 -  )
extern int    Magic             =  0;              //  Magic<1 Magic    ,        
extern int    Slippage          =  3;
string LabelPrefix              =  "ExpertLabel";  //    ,        
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   double MinLot = MarketInfo(Symbol(), MODE_MINLOT);
   double MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double Step = MarketInfo(Symbol(), MODE_LOTSTEP);

   double StopLoss = WindowPriceOnDropped();
   double MoneyRisk = AccountFreeMargin() * Risk;
   double TickValue = MarketInfo(Symbol(), MODE_TICKVALUE);
   string comment=""; 
   double PointLoss;
   double TP=0;
   int cmd;
   double price;
   color ordercolor;
   int    obj_total=ObjectsTotal();
//  ,        	
	for(int i=obj_total+1;i>-1;i--){
      string name=ObjectName(i);
      if(StringFind( name,LabelPrefix,0)>-1){
         comment= StringSubstr(name,StringLen(LabelPrefix),0);
         if(Magic<1)Magic=StrToInteger(ObjectDescription(name));
         Comment("  comment= ",comment,"  Magic= ",Magic);
      }   
   }   
//---
   if(Ask>StopLoss)
   {
      //Open Long
      PointLoss = (Ask - StopLoss) / Point;
      cmd = OP_BUY;
      price = Ask;
      ordercolor=Aqua;//Green;
      if(TakeProfit>0)TP=NormalizeDouble(Ask+Point*TakeProfit,Digits);
   }
   else
   {
      //Open Short
      PointLoss = (StopLoss - Bid) / Point;
      cmd = OP_SELL;
      price = Bid;
      ordercolor=Yellow;//Red;
      if(TakeProfit>0)TP=NormalizeDouble(Bid-Point*TakeProfit,Digits);
   }

   double LotsRough = MoneyRisk / (TickValue * PointLoss);
   if(LotsRough<MinLot)
   {
      Print("Error. You don\'t have enough money!");
      return(0);
   }
   
   double Lots = MaxLot;
   for(double CheckedLot=MinLot; CheckedLot<=MaxLot; CheckedLot+=Step)
   {
      if(CheckedLot>LotsRough)
      {
         Lots = CheckedLot - Step;
         break;
      }
   }
   
   //Print("Lots=",Lots);
   if(Lot>0) Lots=Lot;
   int ticket = OrderSend(Symbol(), cmd, Lots, price, Slippage, StopLoss,TP, comment, Magic, 0, ordercolor);
   if (ticket<0)
   {
      Print("Error: ", ErrorDescription(GetLastError()));
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+